/*
 * OpenGL-like API for testing __thread variables in shared libraries.
 *
 * Gareth Hughes <gareth@nvidia.com>
 */

#include "foo.h"
#include "foo-internal.h"

void __foo_Color3f(float x, float y, float z)
{
    foo_context_t *ctx = __foo_context;

    ctx->color[0] = x;
    ctx->color[1] = y;
    ctx->color[2] = z;
    ctx->color[3] = 1.0;

    ctx->flags |= FOO_COLOR;
}

void __foo_Vertex3f(float x, float y, float z)
{
    foo_context_t *ctx = __foo_context;

    ctx->position[0] = x;
    ctx->position[1] = y;
    ctx->position[2] = z;
    ctx->position[3] = 1.0;

    ctx->flags = 0;
}
