/*
 * OpenGL-like shared library frontend, for __thread variables testing.
 *
 * Gareth Hughes <gareth@nvidia.com>
 */

#include <stdlib.h>

#include "foo.h"
#include "foo-internal.h"

__thread foo_context_t *__foo_context;
__thread foo_dispatch_t *__foo_dispatch;

static void foo_init(void) __attribute__ ((constructor));

static void foo_init(void)
{
    foo_context_t *ctx;
    foo_dispatch_t *dt;

    ctx = (foo_context_t *) calloc(1, sizeof(foo_context_t));
    dt = (foo_dispatch_t *) calloc(1, sizeof(foo_dispatch_t));

    dt->Color3f = __foo_Color3f;
    dt->Vertex3f = __foo_Vertex3f;

    __foo_context = ctx;
    __foo_dispatch = dt;
}

/*
 * Should be able to be reduced to:
 *      movl %gs:__foo_dispatch@ntpoff, %eax
 *      jmpl *(%eax)
 */
void fooColor3f(float x, float y, float z)
{
    __foo_dispatch->Color3f(x, y, z);
}

/*
 * Should be able to be reduced to:
 *      movl %gs:__foo_dispatch@ntpoff, %eax
 *      jmpl *4(%eax)
 */
void fooVertex3f(float x, float y, float z)
{
    __foo_dispatch->Vertex3f(x, y, z);
}
